module.exports = {
    motion: {
        "motion_movesteps": {
            name: "move (param1) steps",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_turnright": {
            name: "turn right (param1) degrees",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_turnleft": {
            name: "turn left (param1) degrees",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_goto": {
            name: "go to (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menupot1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_gotoxy": {
            name: "go to x: (param1) y: (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_glideto": {
            name: "glide (param1) secs to (menuopt1 v)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_glidesecstoxy": {
            name: "glide (param1) secs to x: (param2) y: (param3)",
            value: 3,
            field: 0,
            valueArgs: ['param1', 'param2', 'param3'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_pointindirection": {
            name: "point in direction (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_pointtowards": {
            name: "point towards (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_changexby": {
            name: "change x by (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_setx": {
            name: "set x to (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_changeyby": {
            name: "change y by (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_sety": {
            name: "set y to (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_ifonedgebounce": {
            name: "if on edge bounce",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_setrotationstyle": {
            name: "set rotation style [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "motion_xposition": {
            name: "x position",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_yposition": {
            name: "y position",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "motion_direction": {
            name: "direction",
            value: 0,
            field: 0,
            valueArgs: [],
            substack: false,
            statement: 0,
        },
    },

    looks: {
        "looks_sayforsecs": {
            name: "say (param1) for (param2) seconds",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_say": {
            name: "say (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_thinkforsecs": {
            name: "think (param1) for (param2) seconds",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_think": {
            name: "think (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_switchcostumeto": {
            name: "switch costume to (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_nextcostume": {
            name: "next costume",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_switchbackdropto": {
            name: "switch backdrop to (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_nextbackdrop": {
            name: "next backdrop",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_changesizeby": {
            name: "change size by (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_setsizeto": {
            name: "set size to (param1) %",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_changeeffectby": {
            name: "change [menuopt1 v] effect by (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "looks_seteffectto": {
            name: "set [menuopt1 v] effect to (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "looks_cleargraphiceffects": {
            name: "clear graphic effects",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_show": {
            name: "show",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_hide": {
            name: "hide",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "looks_gotofrontback": {
            name: "go to [menuopt1 v] layer",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "looks_goforwardbackwardlayers": {
            name: "go to [menuopt1 v] (param1) layers",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "looks_costumenumbername": {
            name: "costume (menuopt1 v)",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "looks_backdropnumbername": {
            name: "backdrop (menuopt1 v)",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "looks_size": {
            name: "size",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        }
    },

    sound: {
        "sound_playuntildone": {
            name: "play sound (menuopt1 v) until done",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sound_play": {
            name: "play sound (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sound_stopallsounds": {
            name: "stop all sounds",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sound_changeeffectby": {
            name: "change [menuopt1 v] effect by (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "sound_seteffectto": {
            name: "set [menuopt1 v] effect to (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "sound_cleareffects": {
            name: "clear sound effects",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sound_changevolumeby": {
            name: "change volume by (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sound_setvolumeto": {
            name: "set volume to (param1) %",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sound_volume": {
            name: "volume",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
    },

    event: {
        "event_whenflagclicked": {
            name: "when green flag clicked",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "event_whenkeypressed": {
            name: "when [menuopt1 v] key pressed",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "event_whenthisspriteclicked": {
            name: "when this sprite clicked",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "event_whenbackdropswitchesto": {
            name: "when backdrop switches to [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "event_whengreaterthan": {
            name: "when [menuopt1 v] > (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "event_whenbroadcastreceived": {
            name: "when I receive [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "event_broadcast": {
            name: "broadcast (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "event_broadcastandwait": {
            name: "broadcast (menuopt1 v) and wait",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
    },

    sensing: {
        "sensing_touchingobject": {
            name: "touching (menuopt1 v)?",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_touchingcolor": {
            name: "touching color [param1]?",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_coloristouchingcolor": {
            name: "color [param1] is touching [param2]?",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_distanceto": {
            name: "distance to (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_askandwait": {
            name: "ask (param1) and wait",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_answer": {
            name: "answer",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_keypressed": {
            name: "key (menuopt1 v) pressed?",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_mousedown": {
            name: "mouse down?",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_mousex": {
            name: "mouse x",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_mousey": {
            name: "mouse y",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_setdragmode": {
            name: "set drag mode [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "sensing_loudness": {
            name: "loudness",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_timer": {
            name: "timer",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_of": {
            name: "[menuopt1 v] of (menuopt2 v)",
            value: 1,
            field: 1,
            valueArgs: ['menutopt2'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "sensing_resettimer": {
            name: "reset timer",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_current": {
            name: "current [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "sensing_of": {
            name: "[menuopt1 v] of (menuopt2 v)",
            value: 1,
            field: 1,
            valueArgs: ['menuopt2'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "sensing_current": {
            name: "current [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "sensing_dayssince2000": {
            name: "days since 2000",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "sensing_username": {
            name: "username",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
    },

    control: {
        "control_wait": {
            name: "wait (param1) seconds",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "control_repeat": {
            name: "repeat (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: true,
            statement: 1,
        },
        "control_forever": {
            name: "forever",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: true,
            statement: 1,
        },
        "control_if": {
            name: "if <param1> them",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: true,
            statement: 1,
        },
        "control_if_else": {
            name: "if <param1> them else",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: true,
            statement: 2,
        },
        "control_wait_until": {
            name: "wait until <param1>",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "control_repeat_until": {
            name: "repeat until <param1>",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: true,
            statement: 1,
        },
        "control_stop": {
            name: "stop [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "control_start_as_clone": {
            name: "when I start as a clone",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "control_create_clone_of": {
            name: "create clone of (menuopt1 v)",
            value: 1,
            field: 0,
            valueArgs: ['menuopt1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "control_delete_this_clone": {
            name: "delete this clone",
            value: 0,
            field: 0,
            valueArgs: [],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
    },

    operator: {
        "operator_add": {
            name: "(param1) + (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_subtract": {
            name: "(param1) - (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_multiply": {
            name: "(param1) * (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_divide": {
            name: "(param1) / (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_random": {
            name: "pick random (param1) to (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_gt": {
            name: "<(param1) > (param2)>",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_lt": {
            name: "<(param1) < (param2)>",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_equals": {
            name: "<(param1) = (param2)>",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_and": {
            name: "<<param1> and <param2>>",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_or": {
            name: "<<param1> or <param2>>",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_not": {
            name: "<not <param1>>",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_join": {
            name: "join (param1) (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_letter_of": {
            name: "letter (param1) of (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_length": {
            name: "length of (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_contains": {
            name: "<(param1) contains (param2)?>",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_mod": {
            name: "(param1) mod (param2)",
            value: 2,
            field: 0,
            valueArgs: ['param1', 'param2'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_round": {
            name: "round (param1)",
            value: 1,
            field: 0,
            valueArgs: ['param1'],
            fieldArgs: [],
            substack: false,
            statement: 0,
        },
        "operator_mathop": {
            name: "[menuopt1 v] of (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
    },

    data: {
        "data_setvariableto": {
            name: "set [menuopt1 v] to (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "data_changevariableby": {
            name: "change [menuopt1 v] by (param1)",
            value: 1,
            field: 1,
            valueArgs: ['param1'],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "data_showvariable": {
            name: "show variable [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
        "data_hidevariable": {
            name: "hide variable [menuopt1 v]",
            value: 0,
            field: 1,
            valueArgs: [],
            fieldArgs: ['menuopt1'],
            substack: false,
            statement: 0,
        },
    }
}